function allocatecol_for_res(T, s)
    InMemoryDatasets.Missings.missings(T, s)
end

function find_end_of_line(buff, lo, hi, eol)
    eol_len = length(eol)
    last_eol = last(eol)
    first_eol = first(eol)

    @inbounds for i in (lo+eol_len-1):hi
        buff[i] == last_eol && buff[i - eol_len + 1] == first_eol && return i - eol_len
    end
    # couldn't find line break characters
    return hi
end

@inline function find_next_delim(buffer, lo, hi, dlm, dlmstr)
    if dlmstr === nothing
        @inbounds for i in lo:hi
            buffer[i] in dlm && return i,0,0
        end
    else
        dlmstr_len = length(dlm)
        dlmstr_last = last(dlm)
        @inbounds for i in lo+dlmstr_len-1:hi
            if buffer[i] == dlmstr_last

                flag = true
                for j in 1:dlmstr_len-1
                    if buffer[i - j] != dlm[dlmstr_len - j]
                        flag = false
                        break
                    end
                end
                flag && return i,0,0
            end
        end
    end
    return 0,0,0
end

# this needs refactoring
@inline function find_next_delim(buffer, lo, hi, dlm, dlmstr, qut, qutesc)
    new_lo = 0
    new_hi = 0
    if dlmstr === nothing || length(dlm) == 1
        i = lo
        @inbounds while true
            if buffer[i] == qut
                if i>lo# && buffer[i-1] != qutesc
                    eoq_loc = find_next_quote(buffer, i+1, hi, qut, qutesc)
                    eoq_loc == 0 && return 0,0,0
                    new_lo = i+1
                    new_hi = eoq_loc-1
                    i = eoq_loc + 1
                elseif i == lo
                    eoq_loc = find_next_quote(buffer, i+1, hi, qut, qutesc)
                    eoq_loc == 0 && return 0,0,0
                    new_lo = i+1
                    new_hi = eoq_loc-1
                    i = eoq_loc + 1
                end
            end
            if buffer[i] in dlm
                return i,new_lo,new_hi
            end
            i += 1
            i > hi && return 0,new_lo, new_hi
        end
    else
        dlmstr_len = length(dlm)
        dlmstr_last = last(dlm)
        i = lo
        # take care of the first few values
        @inbounds while true
            if buffer[i] == qut
                if i>lo #&& buffer[i-1] != qutesc
                    i > lo+dlmstr_len-1 && break
                    eoq_loc = find_next_quote(buffer, i+1, hi, qut, qutesc)
                    eoq_loc == 0 && return 0,0,0
                    new_lo = i+1
                    new_hi = eoq_loc-1
                    i = eoq_loc + 1
                elseif i == lo
                    eoq_loc = find_next_quote(buffer, i+1, hi, qut, qutesc)
                    eoq_loc == 0 && return 0,0,0
                    new_lo = i+1
                    new_hi = eoq_loc-1
                    i = eoq_loc + 1
                end
            end
            i += 1
            (i > lo+dlmstr_len-1 || i > hi) && break
        end
        i > hi && return 0,new_lo, new_hi
        @inbounds while true #for i in lo+dlmstr_len-1:hi
            if buffer[i] == qut
                eoq_loc = find_next_quote(buffer, i+1, hi, qut, qutesc)
                eoq_loc == 0 && return 0,0,0
                new_lo = i+1
                new_hi = eoq_loc-1
                i = eoq_loc + 1
            end

            if buffer[i] == dlmstr_last
                flag = true
                for j in 1:dlmstr_len-1
                    if buffer[i - j] != dlm[dlmstr_len - j]
                        flag = false
                        break
                    end
                end
                flag && return i, new_lo, new_hi
            end
            i += 1
            i > hi && return 0,0,0
        end
    end
    return 0,0,0
end

@inline function find_next_quote(buffer, lo, hi, qut, qutesc)
    @inbounds if qut !== qutesc
        for i in lo:hi
            buffer[i] == qut && buffer[i-1] != qutesc && return i
        end
    else
        for i in lo:hi
            if buffer[i] == qut
                if i < hi && i > lo+1 #interior
                    buffer[i+1] != qut && buffer[i-1] != qut && return i
                elseif i <= lo + 1 && i < hi
                    buffer[i+1] != qut && return i
                elseif i == hi && i > lo + 1
                    return i
                elseif i == hi
                    return i
                end
            end
        end
    end
    return 0
end

#basic idea to remove escapechar
function remove_escape_char(buffer, lo, hi, qut, qutesc)
    cnt = lo
    for i in lo:hi
        if buffer[i] == qut
            cnt -= 1
            buffer[cnt] = buffer[i]
        else
            buffer[cnt] = buffer[i]
        end
        cnt += 1
    end
    lo, cnt - 1
end


# when eol is \r\n
@inline function find_next_delim_or_end_of_line(buffer, field_start, dlm, eol::Vector{UInt8})
    @inbounds for i in field_start:length(buffer)
        if buffer[i] in dlm
            return false, i
        elseif buffer[i] == eol[1] && buffer[i+1] == eol[2]
            return true, i+1
        end
    end
    return true, length(buffer)
end

@inline function check_if_a_buffer_has_end_of_line(buff, lo, hi, eol::UInt8)
    for i in lo:hi
        buff[i] == eol && return true,i
    end
    return false,0
end
@inline function check_if_a_buffer_has_end_of_line(buff, lo, hi, eol::Vector{UInt8})
    for i in lo:hi-1
        buff[i] == eol[1] && buff[i+1] == eol[2]  && return true,i
    end
    return false,0
end



# function move_cursor(eol_reached, dlm_pos, dlm, eol)
#     eol_reached ? return dlm_pos+length(eol) : return dlm_pos + length(dlm)
# end


@inline function _find_how_many_dlm(headerl, dlm)
    cnt = 1
    for c in headerl
        c in dlm ? cnt += 1 : nothing
    end
    cnt
end

function tryparse_with_missing(T, x, infmt)
    ismissing(x) && return 1
    _tmp = LineBuffer(collect(codeunits(x)))
    lo = 1
    hi = length(x)
    if infmt !== identity
        infmt(_tmp, lo, hi)
    end
    flag = true
    @simd for i in lo:hi
        @inbounds if (_tmp.data[i] == 0x20 || _tmp.data[i] == 0x2e)
            flag &= true
        else
            flag &= false
        end
    end
    flag && return 1
    ismissing(_tmp) ? 1 : Int(tryparse(T, _tmp) !== nothing)
end

function r_type_guess(x, infmt)
    T = Int
    flag = true
    for i in 1:length(x)
        res = tryparse_with_missing(T, x[i], infmt)
        if res == 0
            flag = false
            break
        end
    end
    flag && return T
    T = Float64
    flag = true
    for i in 1:length(x)
        res = tryparse_with_missing(T, x[i], infmt)
        if res == 0
            flag = false
            break
        end
    end
    flag && return T
    return String
end



function count_lines_of_file(path, lo, hi, eol)
    f = open(path, "r")
    eol_last = last(eol)
    eol_first = first(eol)
    eol_len = length(eol)

    a = Vector{UInt8}(undef, 8192)
    nl = nb = 0
    cur_position = lo
    seek(f, max(0, lo-1))
    @inbounds while !eof(f) && cur_position <= hi
        nb = readbytes!(f, a)
        cur_position = position(f)
        if cur_position > hi
            last_nb = nb - (cur_position - hi)
        else
            last_nb = nb
        end
        if eol_len == 2 && cur_position != hi
            seek(f, cur_position - 1)
        end
        for i=eol_len:last_nb
            nl += (a[i] == eol_last && a[i - eol_len + 1] == eol_first)
        end
    end
    if eof(f) && nb > 0 && (a[nb] != eol_last || a[nb - eol_len + 1] != eol_first)
        nl += 1 # final line is not terminated with eol
    end
    close(f)
    nl
end


function estimate_linesize(path, eol, lsize; guessingrows = 20)
    f = open(path, "r")
    try
        _tmp_line = Vector{UInt8}(undef, lsize*guessingrows)
        line_estimate = 0
        cnt = 1
        cnt_read_bytes = readbytes!(f, _tmp_line)
        eol_first = first(eol)
        eol_last = last(eol)
        eol_len = length(eol)

        l_len = 0
        for i in eol_len:cnt_read_bytes
            if _tmp_line[i] == eol_last && _tmp_line[i - eol_len + 1] == eol_first
                if l_len > line_estimate
                    line_estimate = l_len
                end
                cnt += 1
                cnt > guessingrows && break
                l_len = 0
            end
            l_len += 1
        end
        line_estimate
    catch e
        close(f)
        rethrow(e)
    end
end

function read_one_line(path, lo, hi, eol)
    f = open(path, "r")
    try
        _tmp_line = Vector{UInt8}(undef, 8192)

        seek(f, max(0, lo - 1))

        eol_first = first(eol)
        eol_last = last(eol)
        eol_len = length(eol)

        f_pos = 0

        l_len = 0
        reached_eol = false
        while !eof(f)
            nb = readbytes!(f, _tmp_line)
            cur_position = position(f)
            if cur_position > hi
                last_nb = nb - (cur_position - hi)
            else
                last_nb = nb
            end
            l_len += eol_len-1
            for i in eol_len:last_nb
                l_len += 1
                if _tmp_line[i] == eol_last && _tmp_line[i - eol_len + 1] == eol_first
                    reached_eol = true
                    break
                end
            end
            reached_eol && break
        end
        close(f)
        # length of line and position of file at the end of line
        (l_len, lo+l_len-1)
    catch e
        close(f)
        rethrow(e)
    end
end


function _generate_colname_based(path, eol, lo, hi, lsize, types, delimiter, linebreak, buffsize, colwidth, dlmstr, quotechar, escapechar, autogen)
    _lvarnames, f_pos = read_one_line(path, lo, hi, eol)
    _varnames = [Vector{Union{String, Missing}}(undef, 1) for _ in 1:length(types)]
    readfile_chunk!(_varnames, 1,1, [], path, repeat([String], length(types)), 1, lo, f_pos, nothing; delimiter = delimiter, linebreak = linebreak, buffsize = buffsize, fixed = colwidth, dlmstr = dlmstr, quotechar = quotechar, escapechar = escapechar)
    varnames = Vector{String}(undef, length(types))
    cnter = 1
    for i in 1:length(_varnames)

        if ismissing(_varnames[i][1])
            if autogen
                varnames[i] = "NONAME"*string(cnter)
                cnter += 1
            else
                throw(ArgumentError("the variable name inference is not valid, setting `header = false` may solve the issue."))
            end
        else
            varnames[i] = _varnames[i][1]
        end
    end
    f_pos, Symbol.(strip.(varnames))
end

function guess_eol_char(path)
    f = open(path, "r")

    LF = UInt8('\n')
    CR = UInt8('\r')

    a = Vector{UInt8}(undef, 8192)
    while !eof(f)
        nb = readbytes!(f, a)
        for i in 1:nb
            if a[i] == LF && a[i-1] == CR
                close(f)
                return ['\r', '\n']
            elseif a[i] == LF
                close(f)
                return '\n'
            end
        end
    end
    close(f)
    throw(ArgumentError("end of line is not detectable, set `linebreak` argument manually"))
end


_todate(s::AbstractString) = DateFormat(s)
_todate(s::DateFormat) = s
_todate(::Any) = throw(ArgumentError("DateFormat must be a string or a DateFormat"))


@inline function _write_warn_detail(buff, l_st, l_en, res, cur_l, col)::String
    txt = "\n"
    for j in 1:length(col)
        txt *= string(col[j])
        txt *= "::" * string(nonmissingtype(eltype(res[j])))
        txt *= " = "
        txt *= string(res[j][cur_l])
        if j < length(col)
            txt *= ", "
        else
            txt *= "\n"
        end
    end
    txt *= unsafe_string(pointer(buff, l_st), l_en - l_st + 1)
end
